// This benchmarks tests detection of non-destructive operation: iteration
// in a list. First, a DLL is created (has to be), and then we iterater inside
// the list 'forward' or 'backward' repetitively. Both the number of iterations
// and direction are decided non-deterministically in each repetition.
#include <stdlib.h>
typedef struct SNode
{
    int r;
    struct SNode *q;
    struct SNode *w;
} Node;
#define nondet() (rand() % 5)
int main()
{
    int i = 0;
    Node *h = NULL;
    Node *t = NULL;
    Node *p;
    for ( ; i < 10; ++i)
    {
        Node *f = (Node*)malloc(sizeof(Node));
        f->w = NULL;
        f->r = i % 3;
        if (t == NULL)
            t = f;
        else
            h->w = f;
        f->q = h;
        h = f;
    }
    p = h;
    while (nondet())
    {
        if (nondet())
        {
            if (p != t)
                p = p->q;
        }
        else
        {
            if (p != h)
                p = p->w;
        }
    }
    // MEMORY LEAK (BUT WE DO NOT CARE AS WE ONLY FOCUS ON ITERATION!)
    return h != 0;
}

