// This is the running example from the paper. It combines a creation of a DLL
// of non-deterministic length and then it iterates through the DLL from its
// head to the tail.
#include <stdlib.h>
typedef struct SNode
{
    int x;
    struct SNode *f;
    struct SNode *b;
} Node;
#define nondet() (rand() % 5)
int main()
{
    Node *h = NULL;
    Node *t = NULL;
    while (nondet())
    {
        Node *p = (Node*)malloc(sizeof(Node));
        if (h == NULL)
            h = p;
        else
            t->f = p;
        p->f = NULL;
        p->x = nondet();
        p->b = t;
        t = p;
    }
    Node* p = h;
    while (p != NULL)
    {
        p->x = 0;
        p = p->f;
    }
    // MEMORY LEAK (BUT WE DO NOT CARE AS WE ONLY FOCUS ON CREATION/ITERATION!)
    return h != 0;
}

