
// Warning: contains memory leak (no list deleting)
// fill, rewrite and create sublist, then check by iteration

#include <stdlib.h>
#include <stdio.h>

struct list2 {
    struct list2 * succ;
    int data;
};

#define create(f) {			\
    struct list2 *first = NULL;		\
    while(__VERIFIER_nondet_int()) {    \
        struct list2 *p = malloc(sizeof(struct list2));	\
        p->succ = first;		\
        p->data = 0;			\
        first = p;			\
    }                                   \
    (f) = first;                        \
}

// data struct
struct list_item {
    struct list_item *next;
    struct list_item *prev;
    int data;
    struct list2 *l2;
};

void ERROR() {
    puts("ERROR");
    exit(1);
}

int main() {
    struct list_item *head = NULL;
    struct list_item *tail = NULL;

    const int size = 10;// __VERIFIER_nondet_int();
    int i;
    for(i=0; i < size; ++i) {
        {  
            //printf("LIST.add(%d)\n",i);
            struct list_item *p = malloc(sizeof(struct list_item));
            if(p==NULL) ERROR();
            p->next = NULL;
            p->data = i;
            p->prev = tail;
            if (tail!=NULL) {
                tail->next = p;
                tail = p;
            } else {
                head = p;
                tail = p;
            }
            p->l2 = NULL;       // empty sublist
        }  
    }
    struct list_item *it = head;
    while (it != NULL) {
        it->data = 10;
        //printf("LIST *iterator%p\n", it);
        create(it->l2);         // replace sublist
        it = it->next;
    }
    it = head;
    while (it != NULL) {
        int cur = it->data;
        //printf("LIST *iterator%p = %d\n", it, cur);
        if (cur != 10) ERROR();
        it = it->next;
    }
    return 0;
}

