// Another possible variant of the pop_front operation.
// - DLL without tail pointer
// Of course, we have to create a DLL first...
#include <stdlib.h>
typedef struct SNode
{
    int x;
    struct SNode *f;
    struct SNode *b;
} Node;

Node *h = NULL;

int main()
{
    int i;
    for (i=0 ; i < 5; ++i)
    {
        Node *p = (Node*)malloc(sizeof(Node));
        if (h == NULL) {
            p->b = NULL;
            h = p;
        }
        else {
            Node *t=h;
            while(t->f != NULL)
                t = t->f;
            t->f = p;
            p->b = t;
        }
        p->f = NULL;
        p->x = 0;
    }
    while (h != NULL)
    {
        Node *x = h;
        Node *p = x->f;
        if (p != NULL)
            p->b = NULL;
        h = p;
        free((void*)x);
    }
    return h != 0;
}

