
// Warning: contains memory leak (no list deleting)
// simple doubly-linked list push_back implementation
// fill by seq 1 N, then check contents by iteration

#include <stdlib.h>
#include <stdio.h>

struct list_item {
    struct list_item *next;
    struct list_item *prev;
    int data;
};

void ERROR() {
    puts("ERROR");
    exit(1);
}

int main() {
    struct list_item *head = NULL;
    struct list_item *tail = NULL;

    const int size = 5;
    int i = 0;
    while(i < size) {
        i = i + 1;
        {  
            //printf("LIST.add(%d)\n",i);
            struct list_item *p = malloc(sizeof(struct list_item));
            if (!p)
                ERROR();
            p->next = NULL;
            p->data = i;
            if (tail) {
                p->prev = tail;
                tail->next = p;
                tail = p;
            } else {
                p->prev = NULL;
                head = p;
                tail = p;
            }
        }  
    }
    i=0;
    struct list_item *it = head;
    int cur;
    while (it != NULL) {
        i = i + 1;
        cur = it->data;
        //printf("LIST *iterator%p = %d\n", it, cur);
        it = it->next;
        if (cur != i) ERROR();
    }
    return i;
}

